<?php
  /*
* Project:     Morgdkp2 eqdkp plus plug-in
* License:     Creative Commons - Attribution-Noncommercial-Share Alike 3.0 Unported
* Link:    http://creativecommons.org/licenses/by-nc-sa/3.0/
* -----------------------------------------------------------------------
* Began:       2013
* -----------------------------------------------------------------------
* @author      BlueWarlord
* @copyright   2013-
* Based upon the EQdkp-Plus epgpimport plug-in and Morgalm's original morgdkp 2 plug-in for eqkdp plus 0.6
*/


if(!defined('EQDKP_INC')) {
  header('HTTP/1.0 Not Found');
  exit;
}
$eqdkp_root_path = './../../../';
include_once($eqdkp_root_path.'common.php');

if(!class_exists('morgdkp2_functions')) {
	class morgdkp2_functions extends gen_class {
		public static $shortcuts = array('in', 'pdh', 'user', 'config', 'time','db');
		private $pdl;
		
		
		public function __construct() {
			// Sort out the debug logger
			//$this->pdl = registry::register('plus_debug_logger');
			//$this->pdl->register_type("morgdkp2", null, null, null, "morgdkp2.log");
			//$this->pdl->log("morgdkp2", "Constructing functions class" );
		}
		
		public function setArrayValue(&$array, $stack, $value) {
			if ($stack) {
				$key = array_shift($stack);
				$this->setArrayValue($array[$key], $stack, $value);
				return $array;
			} else $array = $value;
			
		}
				
		public function FetchMember($eqdkp, $table_prefix, $name) {
			$sql = "SELECT member_name, member_id FROM " . $table_prefix . 'members' . " WHERE member_name = '$name'";
			$result = $this->db->query($sql);
			
			while ( $row = $this->db->fetch_record($result) ){
				$temp = $row['member_id'];          
			}
			//$this->db->free_result($result);                
			
			return $temp;
		} // End of FetchMember()
		
		public function CheckAlias($names, $eqdkp, $table_prefix) {
			$aliases = $this->FetchAllAliases($eqdkp, $table_prefix);
			if (empty($aliases) || empty($names) ) return $names;
			foreach ($names as $num => $alt) {
				$alt = rtrim($alt);
				$alt = ucwords($alt);
				foreach ($aliases as $alias) {
					if ($alt == $alias['alias_name']) {
						$names[$num] = $alias['member_name'];
						break;
					}
				}
			}
			return $names;
		}  // End of CheckAlias()
		
		private function FetchAllAliases($eqdkp, $table_prefix) {
			$sql = "SELECT alias_id, alias_name, alias_member_id, member_name, member_id FROM " . $table_prefix .
			'ctrt_aliases' . ", " . $table_prefix . 'members' . " WHERE member_id = alias_member_id";
			$result = $this->db->query($sql);
			$temp = array();
			if ($result) {
				while ($row = mysql_fetch_array($result)) {
					$temp[] = array("alias_id"=>$row["alias_id"],
							"alias_name"=>stripslashes($row["alias_name"]),
							"alias_member_id"=>$row["alias_member_id"],
							"member_name"=>stripslashes($row["member_name"]),
							"member_id"=>$row["member_id"]);
				}
			}
			////$this->db->free_result($result);
			return $temp;        
		} // End of FetchAllAliases()
	
		public function FetchAllRanks() {
			$sql = "SELECT rank_id, rank_name FROM __member_ranks";
			$result = $this->db->query($sql);
	    		$temp = array();
			while ($row = $this->db->fetch_record($result)) {
				$rankid = $row["rank_id"];
				if ($rankid != 0) $temp[$rankid] = $row["rank_name"];
			}
			$this->db->free_result($result);
			return $temp;
		
		}
		
		public function GetDKPPools() {
			$sql = "SELECT * FROM __multidkp";
			$result = $this->db->query($sql);
	    		$temp = array();
			while ($row = $this->db->fetch_record($result)) {
				$temp[$row['multidkp_id']] = $row['multidkp_name'];
			}
			$this->db->free_result($result);
			return $temp;
		
		}
		
		public function FetchAllEvents() {
			$temp = array();
			$sql = "SELECT event_id, event_name, event_value FROM __events ORDER BY event_name";
			$result = $this->db->query($sql);
		    	while ($row = $this->db->fetch_record($result)) {
		    		$temp[$row['event_id']] = array('event_value'=>$row['event_value'], 'event_name'=>$row['event_name']);
		    	}
		    	$this->db->free_result($result);
		    	return $temp;
		}
		
		public function FetchAliasSimple() {
			$temp = array();
			$sql = "SELECT alias_id, alias_member_id, alias_name, member_id, member_name FROM __ctrt_aliases, __members WHERE member_id = alias_member_id";
			$result = $this->db->query($sql);
			while ($row = $this->db->fetch_record($result)) {
				$temp[$row["alias_name"]] = $row["member_name"];
			}
			$this->db->free_result($result);
			return $temp;
		}

		

  } // End of morgdkp2_functions class
} // End of if
?>
